package com.mvc.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TReviewCompareExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TReviewCompareExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andTaskReviewIdIsNull() {
            addCriterion("TASK_REVIEW_ID is null");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdIsNotNull() {
            addCriterion("TASK_REVIEW_ID is not null");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdEqualTo(Integer value) {
            addCriterion("TASK_REVIEW_ID =", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdNotEqualTo(Integer value) {
            addCriterion("TASK_REVIEW_ID <>", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdGreaterThan(Integer value) {
            addCriterion("TASK_REVIEW_ID >", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("TASK_REVIEW_ID >=", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdLessThan(Integer value) {
            addCriterion("TASK_REVIEW_ID <", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdLessThanOrEqualTo(Integer value) {
            addCriterion("TASK_REVIEW_ID <=", value, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdIn(List<Integer> values) {
            addCriterion("TASK_REVIEW_ID in", values, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdNotIn(List<Integer> values) {
            addCriterion("TASK_REVIEW_ID not in", values, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdBetween(Integer value1, Integer value2) {
            addCriterion("TASK_REVIEW_ID between", value1, value2, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskReviewIdNotBetween(Integer value1, Integer value2) {
            addCriterion("TASK_REVIEW_ID not between", value1, value2, "taskReviewId");
            return (Criteria) this;
        }

        public Criteria andTaskDateIsNull() {
            addCriterion("TASK_DATE is null");
            return (Criteria) this;
        }

        public Criteria andTaskDateIsNotNull() {
            addCriterion("TASK_DATE is not null");
            return (Criteria) this;
        }

        public Criteria andTaskDateEqualTo(String value) {
            addCriterion("TASK_DATE =", value, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateNotEqualTo(String value) {
            addCriterion("TASK_DATE <>", value, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateGreaterThan(String value) {
            addCriterion("TASK_DATE >", value, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateGreaterThanOrEqualTo(String value) {
            addCriterion("TASK_DATE >=", value, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateLessThan(String value) {
            addCriterion("TASK_DATE <", value, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateLessThanOrEqualTo(String value) {
            addCriterion("TASK_DATE <=", value, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateLike(String value) {
            addCriterion("TASK_DATE like", value, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateNotLike(String value) {
            addCriterion("TASK_DATE not like", value, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateIn(List<String> values) {
            addCriterion("TASK_DATE in", values, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateNotIn(List<String> values) {
            addCriterion("TASK_DATE not in", values, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateBetween(String value1, String value2) {
            addCriterion("TASK_DATE between", value1, value2, "taskDate");
            return (Criteria) this;
        }

        public Criteria andTaskDateNotBetween(String value1, String value2) {
            addCriterion("TASK_DATE not between", value1, value2, "taskDate");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNull() {
            addCriterion("DEVICE_SN is null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNotNull() {
            addCriterion("DEVICE_SN is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnEqualTo(String value) {
            addCriterion("DEVICE_SN =", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotEqualTo(String value) {
            addCriterion("DEVICE_SN <>", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThan(String value) {
            addCriterion("DEVICE_SN >", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN >=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThan(String value) {
            addCriterion("DEVICE_SN <", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN <=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLike(String value) {
            addCriterion("DEVICE_SN like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotLike(String value) {
            addCriterion("DEVICE_SN not like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIn(List<String> values) {
            addCriterion("DEVICE_SN in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotIn(List<String> values) {
            addCriterion("DEVICE_SN not in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnBetween(String value1, String value2) {
            addCriterion("DEVICE_SN between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotBetween(String value1, String value2) {
            addCriterion("DEVICE_SN not between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andStationCodeIsNull() {
            addCriterion("STATION_CODE is null");
            return (Criteria) this;
        }

        public Criteria andStationCodeIsNotNull() {
            addCriterion("STATION_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andStationCodeEqualTo(String value) {
            addCriterion("STATION_CODE =", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotEqualTo(String value) {
            addCriterion("STATION_CODE <>", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeGreaterThan(String value) {
            addCriterion("STATION_CODE >", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeGreaterThanOrEqualTo(String value) {
            addCriterion("STATION_CODE >=", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLessThan(String value) {
            addCriterion("STATION_CODE <", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLessThanOrEqualTo(String value) {
            addCriterion("STATION_CODE <=", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLike(String value) {
            addCriterion("STATION_CODE like", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotLike(String value) {
            addCriterion("STATION_CODE not like", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeIn(List<String> values) {
            addCriterion("STATION_CODE in", values, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotIn(List<String> values) {
            addCriterion("STATION_CODE not in", values, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeBetween(String value1, String value2) {
            addCriterion("STATION_CODE between", value1, value2, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotBetween(String value1, String value2) {
            addCriterion("STATION_CODE not between", value1, value2, "stationCode");
            return (Criteria) this;
        }

        public Criteria andReviewValueIsNull() {
            addCriterion("REVIEW_VALUE is null");
            return (Criteria) this;
        }

        public Criteria andReviewValueIsNotNull() {
            addCriterion("REVIEW_VALUE is not null");
            return (Criteria) this;
        }

        public Criteria andReviewValueEqualTo(BigDecimal value) {
            addCriterion("REVIEW_VALUE =", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueNotEqualTo(BigDecimal value) {
            addCriterion("REVIEW_VALUE <>", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueGreaterThan(BigDecimal value) {
            addCriterion("REVIEW_VALUE >", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("REVIEW_VALUE >=", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueLessThan(BigDecimal value) {
            addCriterion("REVIEW_VALUE <", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("REVIEW_VALUE <=", value, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueIn(List<BigDecimal> values) {
            addCriterion("REVIEW_VALUE in", values, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueNotIn(List<BigDecimal> values) {
            addCriterion("REVIEW_VALUE not in", values, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("REVIEW_VALUE between", value1, value2, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andReviewValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("REVIEW_VALUE not between", value1, value2, "reviewValue");
            return (Criteria) this;
        }

        public Criteria andIotDataValueIsNull() {
            addCriterion("IOT_DATA_VALUE is null");
            return (Criteria) this;
        }

        public Criteria andIotDataValueIsNotNull() {
            addCriterion("IOT_DATA_VALUE is not null");
            return (Criteria) this;
        }

        public Criteria andIotDataValueEqualTo(BigDecimal value) {
            addCriterion("IOT_DATA_VALUE =", value, "iotDataValue");
            return (Criteria) this;
        }

        public Criteria andIotDataValueNotEqualTo(BigDecimal value) {
            addCriterion("IOT_DATA_VALUE <>", value, "iotDataValue");
            return (Criteria) this;
        }

        public Criteria andIotDataValueGreaterThan(BigDecimal value) {
            addCriterion("IOT_DATA_VALUE >", value, "iotDataValue");
            return (Criteria) this;
        }

        public Criteria andIotDataValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("IOT_DATA_VALUE >=", value, "iotDataValue");
            return (Criteria) this;
        }

        public Criteria andIotDataValueLessThan(BigDecimal value) {
            addCriterion("IOT_DATA_VALUE <", value, "iotDataValue");
            return (Criteria) this;
        }

        public Criteria andIotDataValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("IOT_DATA_VALUE <=", value, "iotDataValue");
            return (Criteria) this;
        }

        public Criteria andIotDataValueIn(List<BigDecimal> values) {
            addCriterion("IOT_DATA_VALUE in", values, "iotDataValue");
            return (Criteria) this;
        }

        public Criteria andIotDataValueNotIn(List<BigDecimal> values) {
            addCriterion("IOT_DATA_VALUE not in", values, "iotDataValue");
            return (Criteria) this;
        }

        public Criteria andIotDataValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("IOT_DATA_VALUE between", value1, value2, "iotDataValue");
            return (Criteria) this;
        }

        public Criteria andIotDataValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("IOT_DATA_VALUE not between", value1, value2, "iotDataValue");
            return (Criteria) this;
        }

        public Criteria andCompareTypeIsNull() {
            addCriterion("COMPARE_TYPE is null");
            return (Criteria) this;
        }

        public Criteria andCompareTypeIsNotNull() {
            addCriterion("COMPARE_TYPE is not null");
            return (Criteria) this;
        }

        public Criteria andCompareTypeEqualTo(String value) {
            addCriterion("COMPARE_TYPE =", value, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeNotEqualTo(String value) {
            addCriterion("COMPARE_TYPE <>", value, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeGreaterThan(String value) {
            addCriterion("COMPARE_TYPE >", value, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeGreaterThanOrEqualTo(String value) {
            addCriterion("COMPARE_TYPE >=", value, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeLessThan(String value) {
            addCriterion("COMPARE_TYPE <", value, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeLessThanOrEqualTo(String value) {
            addCriterion("COMPARE_TYPE <=", value, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeLike(String value) {
            addCriterion("COMPARE_TYPE like", value, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeNotLike(String value) {
            addCriterion("COMPARE_TYPE not like", value, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeIn(List<String> values) {
            addCriterion("COMPARE_TYPE in", values, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeNotIn(List<String> values) {
            addCriterion("COMPARE_TYPE not in", values, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeBetween(String value1, String value2) {
            addCriterion("COMPARE_TYPE between", value1, value2, "compareType");
            return (Criteria) this;
        }

        public Criteria andCompareTypeNotBetween(String value1, String value2) {
            addCriterion("COMPARE_TYPE not between", value1, value2, "compareType");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}